<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: Script/handleModelData.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: Script/handleModelData.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>/**
 * Calculator module - See {@tutorial staticEngineModel}
 * @module d_handleModelData_client
 * @description  
 * The module exports only one function which is
 * &lt;h4>Exported function : handleDataset&lt;/h4>
 * &lt;h4>call arguments&lt;/h4>
 * postgresData
 * &lt;br> cmpString
 * &lt;br> socket
 * &lt;p> The handler function is attached to the click button event in the dataviz module&lt;/p>
 * [Find the details about the callback function (click to load description)]{@link data.d_1_handler}
 * &lt;h3>Child modules&lt;/h3>
 */

var d3 = window.d3;

/**
 * Configuration structure
 * @typedef {Object} config
 * @property {string} name - key value / identifier
 * @property {string} data - contained data
 * 
 */

/**
 * Array of protected data objects
 * @type {Array&lt;config>} 
  * @description
 * &lt;table>
 * &lt;caption>configData'div'&lt;/caption>
 * &lt;thead>
 * &lt;tr>
 *  &lt;th>name&lt;/th>
 *  &lt;th>data&lt;/th>
 *  &lt;th>description&lt;/th>
 * &lt;/tr>
 * &lt;/thead>
 * &lt;tbody>
 * &lt;tr>
 *  &lt;td>EngineConstants&lt;/td>
 *  &lt;td>'Tamb[K]','Pamb[bar]','R [J/kg/K]','Lambda_ref','E_LHV [J/kg]','C_p[J/kg/K]','Gamma(C_p/C_v)','Fuel H/C Ratio'&lt;/td>
 *  &lt;td>Ambient temp+pressure, spec.gas const, stoich.mass ratio air/fuel ,energy dens.fuel, therm.cap, adiab.const, fuel molec. H to C ratio&lt;/td>
 * &lt;/tr>
 * &lt;tr>
 *   &lt;td>EngineFullLoadData&lt;/td>
 *   &lt;td>N[rpm]	BMEP_full[bar]	dTman[K]	Fman	DFuelSp_mult	Pman/Pamb&lt;/td>
 *   &lt;td>Engine speed, brake mean press. full load, deltaTemp man, des.burned gas frac.man, fuel dens, press.ratio manifold/ambient pres&lt;/td>
 * &lt;/tr>
 * &lt;tr>
 *   &lt;td>EngineAmbientConditions&lt;/td>
 *   &lt;td>'DfuelSp[kg/m^3]/S_p[m/s]&lt;/td>
 *   &lt;td>Desired manifold air temperature (3d map)&lt;/td>
 * &lt;/tr>
 * &lt;tr>
 *   &lt;td>EngineEta&lt;/td>
 *   &lt;td>Fman, Fex&lt;/td>
 *   &lt;td>Engine efficiency as a function of burned gas fraction ration intake to exhaust (3d map)&lt;/td>
 * &lt;/tr>
 * &lt;tr>
 *   &lt;td>EngineFriction&lt;/td>
 *   &lt;td>Dman [kg/m^3] / S_p [m/s][kPa]&lt;/td>
 *   &lt;td>Engine friction in a kPa pressure equivalent as a function of intake air density and piston speed&lt;/td>
 * &lt;/tr>
 * &lt;tr>
 *   &lt;td>EngineVolumEff&lt;/td>
 *   &lt;td>Dman [kg/m^3] / S_p [m/s]&lt;/td>
 *   &lt;td>Volumetric efficiency factor (3d map) as function of intake air density and piston speed&lt;/td>
 * &lt;/tr>
 * &lt;tr>
 *   &lt;td>EngineCompr&lt;/td>
 *   &lt;td>'Ncor[rpm]', 'WcompCor[kg/s]','PrComp[-]','EtaComp[-]','P_ref [Pa]','T_ref [K]','TCompDoCrit [K]'&lt;/td>
 *   &lt;td>corrected compressor wheel speed, corrected mass flow compressor, compr.efficiency, Reference Pressure, Ref Temp, crit./max temp compressor&lt;/td>
 * &lt;/tr>
 * &lt;tr>
 *   &lt;td>EngineData&lt;/td>
 *   &lt;td>'Engine type, 2-stoke:1, 4-Stroke:2','Engine Cylinders','Engine Displacement [m^3]'&lt;/td>
 *   &lt;td>2 or 4 stroke engine, no of cylinders, engine displacement&lt;/td>
 * &lt;/tr>
 * &lt;tr>
 *   &lt;td>EngineTurbine&lt;/td>
 *   &lt;td>'ThVNT','Ncor','PrTurb','WTurbCor','EtaTurb'&lt;/td>
 *   &lt;td>vane position VTG, ratio pressure up/downstream turbine, corrected mass flow across turbine, turbine efficiency&lt;/td>
 * &lt;/tr>
 * &lt;/tbody>
 * &lt;/table>
 */

const configArray = 
[
 {"name": 'EngineConstants', "data":['Tamb[K]','Pamb[bar]','R [J/kg/K]','Lambda_ref','E_LHV [J/kg]','C_p[J/kg/K]','Gamma(C_p/C_v)','Fuel H/C Ratio']},
 {"name": 'EngineFullLoadData', "data":['Engine type, 2-stoke:1, 4-Stroke:2','Engine Cylinders','Engine Displacement [m^3]']},
 {"name": 'EngineAmbientConditions', "data":['DfuelSp[kg/m^3]/S_p[m/s]']},
 {"name": 'EngineEta', "data":['FExh/Fman']},
 {"name": 'EngineFriction', "data":['Dman [kg/m^3] / S_p [m/s][kPa]']},
 {"name": 'EngineVolumEff', "data":['Dman [kg/m^3] / S_p [m/s]']},
 {"name": 'EngineCompr', "data":['Ncor[rpm]', 'WcompCor[kg/s]','PrComp[-]','EtaComp[-]','P_ref [Pa]','T_ref [K]','TCompDoCrit [K]']},
 {"name": 'EngineFullLoadData', "data":['Engine type, 2-stoke:1, 4-Stroke:2','Engine Cylinders','Engine Displacement [m^3]']},
 {"name": 'EngineTurbine', "data":['ThVNT','Ncor','PrTurb','WTurbCor','EtaTurb']},
 {"name": 'EngineExhaustParam', "data":['Assumed Average Turbine Efficiency','Average Exhaust Specific Heat,Cp[J/kg/K]','Average Exhaust Specific Heat Ratio[-]', 
 'Average Gas Constant, R[J/kg/K','Average Exhaust Gas Visc.[Pa*s]','Piece','Pipe Length[mm]','Outer Pipe Diameter[mm]',
 'pieces','Element length[mm]','Element Diameter[mm]','Element Cell Density[1/m^2]','AT element cell wall thickness[mm]','Fraction of cells blocked','Relative Roughness']},
 {"name": 'EngineRawParticulates', "data":['DFuelSp [kg/m^3] / S_p [m/s]']},
 {"name": 'EngineRawNox', "data":['DFuelSp [kg/m^3] / S_p [m/s]']},
 {"name": 'EngineRoadLoads', "data":['Time[s]','Engine Speed[rpm]','BMEP[bar]']}  
] 






 /**
 * Handle data set
 * @param {object} postgresData - process data in json received from postgres db
 * @param {string} cmpString - key value as a string which decides about what editor and visualization shall be chosen for the data
 * @returns {null}
 */

 /** @function 
 * @description exported function : visualize incoming postgres data
 * &lt;p> - the internals of this function are described in the linked namespace
 * &lt;p>{@link data.d_1_handler}
*/

 export function handleDataset(postgresData,cmpString,socket)
 {
     // line module:modulename ~ function name
   /**
     * Foo object (@see: {@link module:handleModelDatar~data})
     * @name data
     * @inner
     * @private
     * @memberof module:handleModelData
     * @property {Object} data - The foo object
     * @property {Object} data.d_1_handler - The bar object     
     * @property {function} data.d_1_handler.function - The bar object     
     */

//------------------------------------------------------------------------------------------------------------
// Documentation of handleDataset content - start
//------------------------------------------------------------------------------------------------------------   
    /**
     * This namespace describes the function body of the mouse click callback function on
     * a calibration parameter in the function selection view. 
     * &lt;br>
     * The function body executes the following steps
     * &lt;li>&lt;a href="data.d_1_handler.html#.remove">1. delete all previous table rows (tr html elements) in the .table class&lt;/a>&lt;/li>
     * &lt;li>&lt;a href="data.d_1_handler.html#.JSON_parse">2. Convert postgres data format from JSON to JS and store it in local object&lt;/a>&lt;/li>
     * &lt;li>&lt;a href="data.d_1_handler.html#.insertHeadline">3. insert / create headline in .table class according to the currently clicked data element name.&lt;/a>&lt;/li>
     * &lt;li>&lt;a href="data.d_1_handler.html#.extractIndexColumn">3. Read index column from engine data&lt;/a>&lt;/li>
     * &lt;li>&lt;a href="data.d_1_handler.html#.insertRow">4. Insert all data into the data rows of the table&lt;/a>&lt;/li>
     * &lt;li>&lt;a href="data.d_1_handler.html#.colorIndexColumn">5. Color the index column (1st column) if data structure is a 3d map&lt;/a>&lt;/li>
     * &lt;li>&lt;a href="data.d_1_handler.html#.createFormattedTableData">6. Create formatted table data for potential storage&lt;/a>&lt;/li>
     * &lt;li>&lt;a href="data.d_1_handler.html#.createSetOfCurveStrc">7. Create configuration structure to convert data into a set of curves&lt;/a>&lt;/li>
     * &lt;li>&lt;a href="data.d_1_handler.html#.storeHTMLTblDatAsCurves">8. Store html table data as a set of curves in postgres&lt;/a>&lt;/li>         
     * &lt;b>Handling of 3d map objects&lt;/b>&lt;br>
     * If the name of the database object appears in a list of map names the object describes a 3d map. 
     * &lt;br>&lt;br>
     * &amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp; 8.2.2 Send variable 'outercollector' by emitting the socket.io event 'tabledata' to the server
     * &lt;p>&lt;/p>
     * @memberof data
     * @type {object}
     * @namespace data.d_1_handler
     */
//------------------------------------------------------------------------------------------------------------
// Documentation of handleDataset content - end
//------------------------------------------------------------------------------------------------------------       

//------------------------------------------------------------------------------------------------------------
// Function insertHeadline - start
//------------------------------------------------------------------------------------------------------------
    /** 
      * @memberof data.d_1_handler
      * @function insertHeadline      
      * @param {string} headline headline text 
      * @description Selects the table identified by its ID attribute 'table' and creates a caption 
      * = headline of the table by filling the innerHTML object member of the caption element with 
      * the headline string.
  */
function insertHeadline(headline) {
  const table = document.getElementById('table');
  // schreibe Tabellenüberschrift
  const caption = table.createCaption();
  caption.innerHTML = headline;
}
//------------------------------------------------------------------------------------------------------------
// Function insertHeadline - end
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
// Function insertRow - start
//------------------------------------------------------------------------------------------------------------
    /** 
      * @memberof data.d_1_handler
      * @function insertRow      
      * @param {string[]} collector column names / column headline numbers
      * @param {string[]} data array of table rows
      * @description This function is called on the receipt of the engine configuration data
      * from postgres. It creates a table out of the header columns (collector) and the data of the postgres
      * engine parameters.&lt;br>&lt;br> The function implements the following steps : 
      * &lt;li>select the empty html table element according to the class identifier 'table'&lt;/li>
      * &lt;li>&lt;b>outer loop = rows iterator&lt;/b> : iterate across all data elements plus one headline (this excludes the index column which is extracted before)&lt;/li>
      * &lt;li>insert new row at the end of the table with each loop revolution&lt;/li>
      * &lt;li>&lt;b>inner loop = columns iterator&lt;/b> : iterate across all column names&lt;/li>
      * &lt;li>&lt;b>1st outer loop iteration (iterator equals zero)&lt;/b> : content = column names = collector array (call argument)&lt;/li>
      * &lt;li>&lt;b>consecutive loop iterations&lt;/b> : content = data[outer loop iterator][inner loop iterator]&lt;/li>
      * &lt;li>&lt;b>stop adding table element and break inner loop if content is empty&lt;/b>&lt;/li>
      * &lt;li>insert a new column cell into the row&lt;/li>
      * &lt;li>&lt;b>Special case 1st row (outer loop iterator equals zero)&lt;/b>: set background color to darkblue&lt;/li>
      * &lt;li>store content in innerHTML of new cell and make the cell content editable by setting the corresponding attribute&lt;/li>
  */
  function insertRow (collector,data) {

    const table = document.getElementById('table');	  
    // loop across all data rows plus headline

    var len = data.length;
    for(var k=0;k&lt;len+1;k+=1)
    {
      // Create 1st row with the column names
      const row = table.insertRow(-1);
      // Row across all column names
      for (var i in collector) 
      { 
         let content; 
        if(k===0)
        {
          // Column name
          content = collector[i];            
        }
        else
        {
          // Data tables
          content = data[k-1][i];
          if (content===null || typeof content===undefined){break;}               
        }
        var zelle = row.insertCell();  
       
        var sel = d3.select(zelle)     
        if(k===0){sel.attr('bgcolor','darkblue');}  
                                        
        var selIn = d3.select(zelle);
        var seldiv = selIn.append('div').attr('contenteditable','true');                      
        seldiv.node().innerHTML = content;	
     }       
    }
  }
//------------------------------------------------------------------------------------------------------------
// Function insertRow - end
//------------------------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------------------------
// Function extractIndexColumn - start
//------------------------------------------------------------------------------------------------------------
    /**    
    * @memberof data.d_1_handler
    * @function extractIndexColumn
    * @param {obj} k iterator over postgres data
    * @param {object[]} configArray configuration array
    * @param {number} length handler function
    * @param {number} cmpString name of calling data object
    * @returns {number[]} 3d map data in case of cmpString parameter 
    * stands for a calibration map. Each row array stands for a column, each
    * element of a row array stands for a row element of the given column. 
    * @description The call parameter 'cmpString' contains the name of
    * the calibration data set which corresponds to the push button. 
    * 'cmpString' is compared to each name in the 'configArray' configuration
    * data structure. If a name in the configuration is equal to call parameter
    * an iteration across the data field of the configuration starts. 
    * &lt;br>
    * &lt;br>
    * &lt;a href="module-d_handleModelData_client.html#~configArray">Find &lt;b>data&lt;/b> in the configuration array (click to find the configuration data field)&lt;/a>
    * &lt;br>&lt;br>
    * &lt;a href="module-d_handleModelData_client.html#~specialMap">If &lt;b>data&lt;/b> represents a calibration map function specialMap returns 'true'&lt;/a>
    * &lt;br>&lt;br>
    * If the data element stands for a calibration map the corresponding columns of the postgres table are pushed to an array named &lt;b>collector&lt;/b>.
    */  

     function extractIndexColumn()
     {
      var result=[];
      for(var cnfIt=0;cnfIt&lt;configArray.length;cnfIt++)
      {
       if(configArray[cnfIt].name===cmpString)
       {
           for(var i in configArray[cnfIt].data)
           {            
               for(var k in Obj.columns)
               {
                   if(Obj.columns[k]===configArray[cnfIt].data[i] || specialMap(cmpString))
                   {
                    result.push(Obj.columns[k]);    
                   }               
               }
           }
       }
      }    
      return result;
     }
//------------------------------------------------------------------------------------------------------------
// Function extractIndexColumn - end
//------------------------------------------------------------------------------------------------------------     
/** 
 * @memberof data.d_1_handler
 * @function specialMap
 * @param cmpString name of the data element which corresponds the clicked push button
 * @description The function returns true if cmpString is equal to one of the following strings
 * &lt;li>EngineAmbientConditions&lt;/li>
 * &lt;li>EngineEta&lt;/li>
 * &lt;li>EngineFriction&lt;/li>
 * &lt;li>EngineVolumEff&lt;/li>
 * &lt;li>EngineRawParticulates&lt;/li>
 * &lt;li>EngineRawNox&lt;/li>
*/
function specialMap(cmpString)
{
    switch(cmpString)
    {
        case 'EngineAmbientConditions' : return true; 
        case 'EngineEta' : return true; 
        case 'EngineFriction' : return true; 
        case 'EngineVolumEff' : return true; 
        case 'EngineRawParticulates' : return true; 
        case 'EngineRawNox' : return true; 
    }
}
//------------------------------------------------------------------------------------------------------------
// Function colorIndexColumn - start
//------------------------------------------------------------------------------------------------------------   
   /**
    * Connect
    * @memberof data.d_1_handler
    * @function colorIndexColumn
    * @param {string} cmpString
    * @description Colors background of the index column darkblue. 
    * This function is executed only if the the call parameter 'cmpString'
    * identifies the data element as a 3d data table. This is the case
    * if the function 'specialMap' returns true.
    * All row (tr) nodes of the table (according to class name 'table')
    * are selected. The d3 method 'select('td')' selects only the 1st
    * td / cell element in a row. Setting the background color
    * attribute 'bgcolor' to 'darkblue' colors the 1st column of 
    * a row. 
 */  
function colorIndexColumn(cmpString)
{
  if(specialMap(cmpString))
  {
    var selNds = d3.select('.table').selectAll('tr').nodes();
    for(var it in selNds)
    {     
        d3.select(selNds[it]).select('td').attr('bgcolor','darkblue')
    }
  }
}
//------------------------------------------------------------------------------------------------------------
// Function colorIndexColumn - end
//------------------------------------------------------------------------------------------------------------     

//------------------------------------------------------------------------------------------------------------
// Function createFormattedTableData - start
//------------------------------------------------------------------------------------------------------------   
  /**    
    * @memberof data.d_1_handler
    * @function createFormattedTableData
    * @description Merges all table data, including the index column
    * into one result vector. &lt;br>&lt;br>
    * 
    * Outer loop : All table row html elements (tr) of a 3d map are 
    * read into a variable (tableHTML) as an array of html nodes &lt;br>&lt;br>
    * Inner loop : the html 'div' elements of all cells of the current
    * table row are read into a nodes array. The data field of all div
    * nodes is pushed into an inner array 'innerCollector'. &lt;br>&lt;br>
    * Outer loop (at return from inner loop) : push the innerCollector array 
    * into the result vector, which is an array of 'innerCollector' arrays. 
    * Foo object (@see: {@link module:handleModelData})
    * 
    */  
function createFormattedTableData()
{
  var result = [];
  
  var tableHTML =  d3.select('.table').selectAll('tr').nodes();
  


  for(var outIt=0;outIt&lt;tableHTML.length;outIt+=1)
  {
       var innerCollector = [];
  
       var cells = d3.select(tableHTML[outIt]).selectAll('div').nodes();
       for(var inIt=0;inIt&lt;cells.length;inIt+=1)
       {
           innerCollector.push(cells[inIt].childNodes[0].data);       
       }
       result.push(innerCollector);
  }

  return result;
}
//------------------------------------------------------------------------------------------------------------
// Function createFormattedTableData - end
//------------------------------------------------------------------------------------------------------------   

//------------------------------------------------------------------------------------------------------------
// Function createSetOfCurveStrc - start
//------------------------------------------------------------------------------------------------------------ 
  /**    
    * @memberof data.d_1_handler
    * @function createSetOfCurveStrc
    * @description Creates and initializes a data structure for compressor and turbine
    * objects. This data structures are used to identify a set of curves
    * in a measurement dataset e.g. there is a triplet of measurement data where
    * the 1st element is constant thoughout one dataset. The transition from 
    * one datset to the other is identified by the change of this 1st element. 
    * If it changes, a new dataset starts. One curve in that set of curves would
    * be signal 2 over signal 3 or vice versa with a constant signal 1. &lt;br>&lt;br>
    * 
    * name : name of the dataset&lt;br>
    * trig : name of the trigger signal i.e. the signal which is constant during set of curves
    * trigNo : column number of the trigger signal in the dataset
    * colNames : the element names of those elements which will be displayed in curves
    * colNmbrs : array of column numbers - each column number position corresponds to the element name and stands 
    * for the column position of the data element in the data vector
    * databuf : contains the data for one set of curve e.g. in case of 4 signals and the first signal is the &lt;br>
    * trigger signal this is a 3 x n vector with n : amount of samples
    * 
    */  
function createSetOfCurveStrc()
{
  var headAr = [];
    /**
    * Turbine object
    * @memberof data.d_1_handler        
    * @typedef {object} Turbine
    * @property {string} name 'EngineTurbine' string identifier is used to find the correct dataset in the configuration
    * @property {string} trig 'ThVNT' string identifier which describes the x-xis of the data multiple x-axis lead to multiple graphs
    * @property {string} trigNo 0 integer ID that characterizes the number of the x axis
    * @property {string} colNames ['PrTurb','WTurbCor','EtaTurb'] y - value identifiers of the 2d graphs
    * @property {number[]} colNmbrs[3] [0,0,0] initialization data
    * @property {number[]} databuf [] values - initialized as an empty array
    * 
    */     

    /**
     * Instance of turbine object
     * @memberof data.d_1_handler        
     *@param {Turbine} TurbineObj
     *@see {@link data.d_1_handler.Turbine}    
     */
     var TurbineObj = {};
     TurbineObj.name = 'EngineTurbine';
     TurbineObj.trig = 'ThVNT';
     TurbineObj.trigNo = 0;
     TurbineObj.trigVal = null;
     TurbineObj.colNames = ['PrTurb','WTurbCor','EtaTurb'];
     TurbineObj.colNmbrs = [0,0,0];
     TurbineObj.databuf = [];
  
       /**
      * Turbine object
      * @memberof data.d_1_handler        
      * @typedef {object} Compressor
      * @property {string} name 'EngineCompr' string identifier is used to find the correct dataset in the configuration
      * @property {string} trig 'Ncor[rpm]' string identifier which describes the x-xis of the data multiple x-axis lead to multiple graphs
      * @property {string} trigNo 0 integer ID that characterizes the number of the x axis
      * @property {string} colNames ['WcompCor[kg/s]','PrComp[-]','EtaComp[-]'] y - value identifiers of the 2d graphs
      * @property {number[]} colNmbrs[3] [0,0,0] initialization data
      * @property {number[]} databuf [] values - initialized as an empty array
      * 
      */     
     
    /**
      * compressor : Instance of turbine object
      * @memberof data.d_1_handler         
      * @param {Turbine} comprObj
      * @see {@link data.d_1_handler.Compressor}    
      */   
  
     var comprObj = {};
     comprObj.name = 'EngineCompr';
     comprObj.trig = 'Ncor[rpm]';
     comprObj.trigNo = 0;
     comprObj.trigVal = null;
     comprObj.colNames = ['WcompCor[kg/s]','PrComp[-]','EtaComp[-]'];
     comprObj.colNmbrs = [0,0,0];
     comprObj.databuf = [];
     
     /**
      * Array : turbine + compressor object
      * @memberof data.d_1_handler         
      * @param {Turbine[]} headAr
      * @description array of turbine &amp; compressor objects
      * &lt;br>var headAr = [TurbineObj,comprObj];
      * &lt;br>[Turbine Object]{@link data.d_1_handler.Turbine}    
      * &lt;br>[Compressor Object]{@link data.d_1_handler.Compressor}    
      */   
     headAr = [TurbineObj,comprObj];

  return headAr; 
}
//------------------------------------------------------------------------------------------------------------
// Function createSetOfCurveStrc - end
//------------------------------------------------------------------------------------------------------------ 

//------------------------------------------------------------------------------------------------------------
// Function findAndStoreColumnPositions - start
//------------------------------------------------------------------------------------------------------------ 
/**    
    * @memberof data.d_1_handler
    * @function findAndStoreColumnPositions(headAr,headIt)
    * @description Finds the signal names of the column names 
    * configuration array in the header array and stores 
    * the positions in the header array. These are the 
    * positions in the dataset. The position numbers
    * are stored in the 'colNmbrs' of the configuration structure &lt;br>
    * The same principle is used for the trigger signal. The name
    * of the trigger signal is found in the header array and the 
    * position number is stored in the 'trigNo' field. 
    */
  
function findAndStoreColumnPositions(headAr,headIt)
{
     /**  
       * @memberof data.d_1_handler        
       * @params {selection} 
       * @description select all cells in the html data table
      */
      var nds = d3.select('.table').select('tr').selectAll('td').nodes()

     //=====================================================================
     // Find columns numbers of column headlines
     // Find column number of trigger signal
     //=====================================================================  
     for(var iNds=0;iNds&lt;nds.length;iNds+=1)
     {
        
        var innerText = d3.select(nds[iNds]).select('div').node().innerHTML;      
        for(var colIt=0;colIt&lt;headAr[headIt].colNames.length;colIt+=1)
        {
          if(innerText===headAr[headIt].colNames[colIt])
          {
            headAr[headIt].colNmbrs[colIt]=iNds; 
          }
        }
        if(innerText===headAr[headIt].trig)
        {
          headAr[headIt].trigNo = iNds;
        }       
     }

  return headAr;
}
//------------------------------------------------------------------------------------------------------------
// Function findAndStoreColumnPositions - end
//------------------------------------------------------------------------------------------------------------ 

//------------------------------------------------------------------------------------------------------------
// Function createEmptyRowArrays - start
//------------------------------------------------------------------------------------------------------------ 
 
/**    
    * @memberof data.d_1_handler
    * @function createEmptyRowArrays
    * @description Initialize the databuffer field of the curves
    * data structure by pushing empty array into it for each signal
    * column according to the configured signal names. 
*/
function createEmptyRowArrays(headAr,headIt)
{
  for(var colIt=0;colIt&lt;headAr[headIt].colNames.length;colIt+=1)
  {     
   headAr[headIt].databuf.push([])
  }     
  return headAr;
}
//------------------------------------------------------------------------------------------------------------
// Function createEmptyRowArrays - end
//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
// Function storeDataOnChangeOfTrigger - start
//------------------------------------------------------------------------------------------------------------
/**    
    * @memberof data.d_1_handler
    * @function storeDataOnChangeOfTrigger    
    * @description The table data is loaded from the html table
    * and split into sets of curves. The sets of curves are
    * send to the server using a socket.io interface. 
    * The server stores the data in postgres.&lt;br>
    * &lt;br>
    * Each row is devided in cells. The cells are organized
    * in columns of a row. Using the configured column position
    * of the trigger signal this function splits a new set of
    * curves by detecting a change in the trigger signal.&lt;br> 
    * On a changed trigger signal a databuffer in the curves
    * datastructure is set to an empty string. The string
    * is filled with each new row as long as the signal in the 
    * trigger columns remains contant. &lt;br>
    * On a change of the trigger signal the previously collected
    * data in the buffer is send to the server where the data
    * is stored in a postgres database before the buffer is freed
    * to receive new data for the next set of curves. 
    */

function storeDataOnChangeOfTrigger(headAr,headIt,inNds,refVal,cntr)
{
       // Find change of trigger signal in current row and store
       // collected array
       for(var iNdsIt=0;iNdsIt&lt;inNds.length;iNdsIt+=1)
       {
       
          var val = parseFloat(d3.select(inNds[iNdsIt]).select('div').node().innerHTML);
          if(iNdsIt === headAr[headIt].trigNo)
          {
            if(!isNaN(val))
            {
              if(val !== refVal)
              {
                  cntr+=1;
                  refVal = val;                                               
                  if(cntr>1)
                  {         
                    /**     
                      * @memberof data.d_1_handler    
                      * @event curvedata
                      * @type {object}
                      * @property {string} table - Indicates whether the snowball is tightly packed.     
                      * @description {@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:curvedata}
                    */                      
                    headAr[headIt].trigVal = val;           
                    socket.emit('curvedata', headAr[headIt]);      
       
                    for(var colIt=0;colIt&lt;headAr[headIt].colNames.length;colIt+=1)
                    {     
                     headAr[headIt].databuf[colIt]=[];
                    }
                    break;                                                    
                  }              
                                    
              }
            }     
          }
        }       
  return [headAr,refVal,cntr];
}
//------------------------------------------------------------------------------------------------------------
// Function storeDataOnChangeOfTrigger - end
//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
// Function bufferColumnData - start
//------------------------------------------------------------------------------------------------------------
/**    
    * @memberof data.d_1_handler
    * @function bufferColumnData    
    * @description The table data is loaded from the html table
    * and split into sets of curves. The sets of curves are
    * send to the server using a socket.io interface. 
    * The server stores the data in postgres.&lt;br>
    * &lt;br>
    * Each row is devided in cells. The cells are organized
    * in columns of a row. Using the configured column position
    * of the trigger signal this function splits a new set of
    * curves by detecting a change in the trigger signal.&lt;br> 
    * On a changed trigger signal a databuffer in the curves
    * datastructure is set to an empty string. The string
    * is filled with each new row as long as the signal in the 
    * trigger columns remains contant. &lt;br>
    * On a change of the trigger signal the previously collected
    * data in the buffer is send to the server where the data
    * is stored in a postgres database before the buffer is freed
    * to receive new data for the next set of curves. 
    */
function bufferColumnData(headAr,headIt,inNds)
{
  for(var iNdsIt=0;iNdsIt&lt;inNds.length;iNdsIt+=1)
  {
    
    var valNw = parseFloat(d3.select(inNds[iNdsIt]).select('div').node().innerHTML);
    if(!isNaN(valNw))
    {
      // Iterate over all column names 
     for(var colIt=0;colIt&lt;headAr[headIt].colNames.length;colIt+=1)
     {
       // If column number of current column name is equal to 
       // current column, then push the corresponding data
       if(iNdsIt === headAr[headIt].colNmbrs[colIt])
       {
         headAr[headIt].databuf[colIt].push(valNw);
       }
     }       
   }
  }
  return headAr;
}
//------------------------------------------------------------------------------------------------------------
// Function bufferColumnData - end
//------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------
// Function sendCurveDataToServer - start
//------------------------------------------------------------------------------------------------------------
/**    
    * @memberof data.d_1_handler
    * @function sendCurveDataToServer    
    * @description The table data is loaded from the html table
    * and split into sets of curves. The sets of curves are
    * send to the server using a socket.io interface. 
    * The server stores the data in postgres.&lt;br>
    * &lt;br>
    * Each row is devided in cells. The cells are organized
    * in columns of a row. Using the configured column position
    * of the trigger signal this function splits a new set of
    * curves by detecting a change in the trigger signal.&lt;br> 
    * On a changed trigger signal a databuffer in the curves
    * datastructure is set to an empty string. The string
    * is filled with each new row as long as the signal in the 
    * trigger columns remains contant. &lt;br>
    * On a change of the trigger signal the previously collected
    * data in the buffer is send to the server where the data
    * is stored in a postgres database before the buffer is freed
    * to receive new data for the next set of curves. 
    */
function sendCurveDataToServer(headAr,headIt)
{
    /**
      * @memberof data.d_1_handler         
      * @param {selection}
      * @description all rows in the engine model cal. value table
      */
     var ndsData = d3.select('.table').selectAll('tr').nodes();
     var refVal=0;
     var cntr = 0;

     for(var iNds=1;iNds&lt;ndsData.length;iNds+=1)
     {
       // Find all table data (td) cells in the current table row
       
       var inNds = d3.select(ndsData[iNds]).selectAll('td').nodes();
       [headAr,refVal,cntr] = storeDataOnChangeOfTrigger(headAr,headIt,inNds,refVal,cntr);  
       headAr = bufferColumnData(headAr,headIt,inNds);
       
     }
}
//------------------------------------------------------------------------------------------------------------
// Function sendCurveDataToServer - end
//------------------------------------------------------------------------------------------------------------ 
//------------------------------------------------------------------------------------------------------------
// Function storeHTMLTblDatAsCurves - start
//------------------------------------------------------------------------------------------------------------ 
/**    
    * @memberof data.d_1_handler
    * @function storeHTMLTblDatAsCurves    
    * @description The table data is loaded from the html table
    * and split into sets of curves. The sets of curves are
    * send to the server using a socket.io interface. 
    * The server stores the data in postgres.&lt;br>
    * &lt;br>
    * Each row is devided in cells. The cells are organized
    * in columns of a row. Using the configured column position
    * of the trigger signal this function splits a new set of
    * curves by detecting a change in the trigger signal.&lt;br> 
    * On a changed trigger signal a databuffer in the curves
    * datastructure is set to an empty string. The string
    * is filled with each new row as long as the signal in the 
    * trigger columns remains contant. &lt;br>
    * On a change of the trigger signal the previously collected
    * data in the buffer is send to the server where the data
    * is stored in a postgres database before the buffer is freed
    * to receive new data for the next set of curves. 
    */
function storeHTMLTblDatAsCurves(headAr)
{
  for(var headIt = 0;headIt&lt;headAr.length;headIt+=1)
   {
     /**
     * @memberof data.d_1_handler         
     * @param {selection}
     * @description all rows in the engine model cal. value table
     */ 
    var headline = d3.select('.table').select('caption').node().innerHTML;

    if(headline===headAr[headIt].name)
    {
    /**     
     * @memberof data.d_1_handler    
     * @event initNewData
     * @type {object}
     * @description This event of the web client triggers a callback function on the server side
     * which prepares a new set of curves for editing and visualization.&lt;br>&lt;br>Find the details
     * about the server sided event in the link &lt;br>
     * [server : start processing new curve data]{@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:initNewData}
     */
     socket.emit('initNewData');
     headAr = findAndStoreColumnPositions(headAr,headIt);
     headAr = createEmptyRowArrays(headAr,headIt);
     sendCurveDataToServer(headAr,headIt);
     return true;
    }// End of specific curve type 
   }// End of loop over all curves
   return false;
}
//------------------------------------------------------------------------------------------------------------
// Function storeHTMLTblDatAsCurves - end
//------------------------------------------------------------------------------------------------------------ 


  /**    
  * @memberof data.d_1_handler        
  * @function remove
  * @parameter {string} .table select table class
  * @parameter {string} tr select table row node
  * @description deletes all rows of the html table element. &lt;br>
  * There is one html table class with a potentially filled table. &lt;br>
  * d3.select('.table') selects the one table class. &lt;br>
  * d3.select('.table').selectAll('tr') selects all table rows in it&lt;br>
  * d3.select('.table').selectAll('tr').remove() removes all table rows but
  * lets the surrounding table element untouched. &lt;br>
  */
   d3.select('.table').selectAll('tr').remove();

  /**  
  * @memberof data.d_1_handler        
  * @function JSON_parse
  * @parameter postgresData data from postgres in JSON format
  * @parameter cmpString string selector which describes the data element which is selected by this mouse event
  * @description JSON_parse converts the JSON object into a Javascript object.
  */
   var Obj = JSON.parse(postgresData[cmpString]);

   insertHeadline(cmpString)

   var collector=[];
   collector=extractIndexColumn();   
   insertRow(collector,Obj.data);
   colorIndexColumn(cmpString);
  
   var outerCollector = [];
   outerCollector = createFormattedTableData();
   
   var headAr = []; 
    headAr = createSetOfCurveStrc();
   if(!storeHTMLTblDatAsCurves(headAr))
   {
      /**     
        * @memberof data.d_1_handler    
        * @event tabledata
        * @type {object}
        * @property {string} table - Indicates whether the snowball is tightly packed.     
        * @description {@link c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.event:tabledata}
      */
      socket.emit('tabledata', outerCollector);
   } 

   return;  
}

</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Connected Controls Web App Docu</a></h2><h3>Modules</h3><ul><li><a href="module-a_index_server.html">a_index_server</a></li><li><a href="module-b_create_caldata_buttons_client.html">b_create_caldata_buttons_client</a></li><li><a href="module-c_socketCom_server.html">c_socketCom_server</a></li><li><a href="module-d_handleModelData_client.html">d_handleModelData_client</a></li><li><a href="module-e_getModelStimulationData_server.html">e_getModelStimulationData_server</a></li><li><a href="module-f_getPostgresData_server.html">f_getPostgresData_server</a></li><li><a href="module-g_setPostgresData_server.html">g_setPostgresData_server</a></li><li><a href="module-h_deletePostgresData_server.html">h_deletePostgresData_server</a></li><li><a href="module-i_getPostgresWOsocket_server.html">i_getPostgresWOsocket_server</a></li><li><a href="module-j_updatePostgresData_server.html">j_updatePostgresData_server</a></li><li><a href="module-k_select-stimulation_client.html">k_select-stimulation_client</a></li><li><a href="module-l_3d_map_visualization_client.html">l_3d_map_visualization_client</a></li><li><a href="module-m_curveGraphGenerator_client.html">m_curveGraphGenerator_client</a></li><li><a href="module-n_create_simulation_view_client.html">n_create_simulation_view_client</a></li><li><a href="module-o_3d_map_visualization_initialization_client.html">o_3d_map_visualization_initialization_client</a></li><li><a href="module-p_3d_map_table_generator.html">p_3d_map_table_generator</a></li></ul><h3>Namespaces</h3><ul><li><a href="audio.k_1_startStimulation.html">k_1_startStimulation</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html">b_1_dataviz</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_1_getClassNames.html">b_1_1_getClassNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_3_getAllButtonNames.html">b_1_3_getAllButtonNames</a></li><li><a href="b_create_caldata_buttons_client.b_1_dataviz.b_1_4_thermdata_client.html">b_1_4_thermdata_client</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html">c_1_socketfunction</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html">c_1_1_socketConnected</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_1_initNewData.html">c_1_1_1_initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_2_tabledata.html">c_1_1_2_tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_3_curvedata.html">c_1_1_3_curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_4_getTable.html">c_1_1_4_getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_5_getCurve.html">c_1_1_5_getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.c_1_1_6_getStimData.html">c_1_1_6_getStimData</a></li><li><a href="data.d_1_handler.html">d_1_handler</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html">m_1_curveGraphGenerator</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html">n_1_create_simulation_view</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html">n_1_1_rcvAudioFilePaths</a></li></ul><h3>Classes</h3><ul><li><a href="d3.html">d3</a></li><li><a href="express.html">express</a></li><li><a href="pool.html">pool</a></li><li><a href="response.html">response</a></li><li><a href="router.html">router</a></li><li><a href="selection.html">selection</a></li><li><a href="server.html">server</a></li><li><a href="socket.html">socket</a></li></ul><h3>Events</h3><ul><li><a href="b_create_caldata_buttons_client.b_1_dataviz.html#.event:thermdata">thermdata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:curvedata">curvedata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:disconnect">disconnect</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getCurve">getCurve</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:getTable">getTable</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:initNewData">initNewData</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:tabledata">tabledata</a></li><li><a href="c_socketCom_server.c_1_socketfunction.c_1_1_socketConnected.html#.event:time">time</a></li><li><a href="c_socketCom_server.c_1_socketfunction.html#.event:connection">connection</a></li><li><a href="data.d_1_handler.html#.event:curvedata">curvedata</a></li><li><a href="data.d_1_handler.html#.event:initNewData">initNewData</a></li><li><a href="data.d_1_handler.html#.event:tabledata">tabledata</a></li><li><a href="module-e_getModelStimulationData_server.html#~event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:getCurve">getCurve</a></li><li><a href="m_curveGraphGenerator_client.m_1_curveGraphGenerator.html#.event:sendCurve">sendCurve</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:getAudioFlPths">getAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:periodic_time">periodic_time</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.html#.event:sendAudioFlPths">sendAudioFlPths</a></li><li><a href="n_create_simulation_view_client.n_1_create_simulation_view.n_1_1_rcvAudioFilePaths.html#.event:click_stimFileSelector">click_stimFileSelector</a></li></ul><h3>Tutorials</h3><ul><li><a href="tutorial-codeAnalysisAndRefactoring.html">Static source code analysis and refactoring interface</a></li><li><a href="tutorial-conceptUnitTest.html">conceptUnitTest</a></li><li><a href="tutorial-graphicalEditor.html">Graphical editor for maps and curves</a></li><li><a href="tutorial-modelStimulation.html">Stimulation of physical and engine control models</a></li><li><a href="tutorial-staticEngineModel.html">Static combustion engine model</a></li><li><a href="tutorial-webclients.html">webclients</a></li></ul><h3>Global</h3><ul><li><a href="global.html#buildNav">buildNav</a></li><li><a href="global.html#publish">publish</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc/jsdoc">JSDoc 3.6.7</a> on Fri Sep 17 2021 09:09:23 GMT+0200 (Mitteleuropäische Sommerzeit)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
